function [interv,tot_iter,max_iter]=Grid_confidence_interval_linear_functional(Y_train,X_train,starting_point,aa)


Over_all_max_iter=100;
[n,p]=size(X_train);
b=aa/(aa'*aa);
Z=X_train*b;
[Ua,~,~]=svd(eye(p,p)-b*aa');Ua(:,end)=[];
W_tilde=X_train*Ua;
[gamma_hat,sigma_u_hat,~,~]=F20151024_scaled_lasso(Z,W_tilde);

x_value_old=starting_point;
step=0.1;
tstat_lb_old=F20160423_second_step(Y_train,Z,W_tilde,p,n,gamma_hat,sigma_u_hat,x_value_old);

if abs(tstat_lb_old)>1.96
    
    
    lb=x_value_old+step;
    tstat_lb=F20160423_second_step(Y_train,Z,W_tilde,p,n,gamma_hat,sigma_u_hat,lb);
    path_tstat=tstat_lb_old;
    path_value=x_value_old;
    if abs(tstat_lb_old)<abs(tstat_lb)
        where=-1;   % starting point is to the left of the interval
    else
        where=1;  % starting point is to the right of the interval
    end
    iter=1;
    max_iter=Over_all_max_iter;
    while iter<=max_iter
        path_value=[path_value;path_value(end)+step*where];
        path_tstat=[path_tstat;F20160423_second_step(Y_train,Z,W_tilde,p,n,gamma_hat,sigma_u_hat,path_value(end))];
        iter=iter+1;
        if (max(abs(path_tstat))>1.96) && (min(abs(path_tstat))<1.96)
            max_iter=0;
        end
    end
    endpoint1=path_value(end-1:end);
    endpoint1_stat=path_tstat(end-1:end);
    tot_iter=iter;
    
    path_tstat=path_tstat(end);
    path_value=path_value(end);
    iter=1;
    max_iter=Over_all_max_iter;
    while iter<=max_iter
        path_value=[path_value;path_value(end)+step*where];
        path_tstat=[path_tstat;F20160423_second_step(Y_train,Z,W_tilde,p,n,gamma_hat,sigma_u_hat,path_value(end))];
        iter=iter+1;
        if (max(abs(path_tstat))>1.96) && (min(abs(path_tstat))<1.96)
            max_iter=0;
        end
    end
    endpoint2=path_value(end-1:end);
    endpoint2_stat=path_tstat(end-1:end);
    tot_iter=tot_iter+iter;
    
    
else
    
    path_tstat=tstat_lb_old;
    path_value=x_value_old;
    iter=1;
    max_iter=Over_all_max_iter;
    while iter<=max_iter
        path_value=[path_value;path_value(end)+step];
        path_tstat=[path_tstat;F20160423_second_step(Y_train,Z,W_tilde,p,n,gamma_hat,sigma_u_hat,path_value(end))];
        iter=iter+1;
        if (max(abs(path_tstat))>1.96) && (min(abs(path_tstat))<1.96)
            max_iter=0;
        end
    end
    endpoint1=path_value(end-1:end);
    endpoint1_stat=path_tstat(end-1:end);
    tot_iter=iter;
    
    path_tstat=tstat_lb_old;
    path_value=x_value_old;
    iter=1;
    max_iter=Over_all_max_iter;
    while iter<=max_iter
        path_value=[path_value;path_value(end)-step];
        path_tstat=[path_tstat;F20160423_second_step(Y_train,Z,W_tilde,p,n,gamma_hat,sigma_u_hat,path_value(end))];
        iter=iter+1;
        if (max(abs(path_tstat))>1.96) && (min(abs(path_tstat))<1.96)
            max_iter=0;
        end
    end
    endpoint2=path_value(end-1:end);
    endpoint2_stat=path_tstat(end-1:end);
    tot_iter=tot_iter+iter;
    
    
    
end


[endpoint1_final,iter]=F20160423_iterative_interpolation(Y_train,Z,W_tilde,p,n,gamma_hat,sigma_u_hat,endpoint1,endpoint1_stat);
tot_iter=tot_iter+iter;
[endpoint2_final,iter]=F20160423_iterative_interpolation(Y_train,Z,W_tilde,p,n,gamma_hat,sigma_u_hat,endpoint2,endpoint2_stat);
tot_iter=tot_iter+iter;
interv=sort([endpoint1_final;endpoint2_final])
end





function [beta_hat_new,sigma_epsl_hat,iter,lambda_final]=F20151024_scaled_lasso(YY,RR)

[n,p]=size(RR);
sigma_epsl_initial=sqrt(YY'*YY/n);
lambda_univ=sqrt(2*log(p)/n);
tol=1e-3;
max_iter=50;
lambda0=lambda_univ;
sigma_epsl_hat=sigma_epsl_initial;

[beta_hat_old]  = lasso(RR,YY,'Lambda',lambda0*sigma_epsl_hat,'Standardize',0);
iter=1;
diff=2*tol;
while (iter<=max_iter) && (diff>tol)
    sigma_epsl_hat=sqrt(sum((YY-RR*beta_hat_old).^2)/n);
    [beta_hat_new]  = lasso(RR,YY,'Lambda',lambda0*sigma_epsl_hat,'Standardize',0);
    diff=max(abs(beta_hat_new-beta_hat_old));
    beta_hat_old=beta_hat_new;
    iter=iter+1;
end
lambda_final=lambda0*sigma_epsl_hat;

end





function [t_stat_unknown_SigmaX]=F20160423_second_step(Y,Z,W_tilde,p,n,gamma_hat,sigma_u_hat,g0)

V=Y-Z*g0;
rho0=0.1;
eta=sqrt(3*log(p)/n);
a1=eta*sqrt(V'*V/n);
a2=rho0*(V'*V)/n*0.5;
pp=p-1;
A0=[-W_tilde'*W_tilde/n,W_tilde'*W_tilde/n,zeros(pp,2),eye(pp,pp),-eye(pp,pp),-W_tilde'*V/n;...
    zeros(pp,2*pp+2),-eye(pp,pp),-eye(pp,pp),zeros(pp,1);...
    -a1*ones(1,2*pp),1,-1,zeros(1,2*pp),a2];
c0=[-W_tilde'*V/n;W_tilde'*V/n;1;-rho0;zeros(2*pp,1);V'*V/n];
b0=[zeros(pp,1);ones(pp,1);0];
[~,lambda,~]=F20151120_linprog_interior_point(A0,-b0,c0,30,1e-4);
pi_hat=lambda(1:pp);
pi_hat=(abs(pi_hat)>1e-6).*pi_hat;

sigma_epsl_hat=sqrt(mean((V-W_tilde*pi_hat).^2));

t_stat_unknown_SigmaX=(Z-W_tilde*gamma_hat)'*(V-W_tilde*pi_hat)/(sqrt(n)*sigma_u_hat*sigma_epsl_hat);

end



function [x,lambda,Num_iter]=F20151120_linprog_interior_point(AA,bb,cc,max_iter,Tol_err)
% Mehrotra (1992): Algorithm 14.3 in Nocedal and Wright book

[~,n]=size(AA); % we need rank(AA)=m
k=0;



x_tilde=(AA'/(AA*AA'))*bb;
lambda_tilde=(AA*AA')\(AA*cc);
s_tilde=cc-AA'*lambda_tilde;
delta_x=max(-1.5*min(x_tilde),0);
delta_s=max(-1.5*min(s_tilde),0);
x_hat=x_tilde+delta_x*ones(n,1);
s_hat=s_tilde+delta_s*ones(n,1);
delta_x_hat=0.5*(x_hat'*s_hat)/(ones(1,n)*s_hat);
delta_s_hat=0.5*(x_hat'*s_hat)/(ones(1,n)*x_hat);

x=x_hat+delta_x_hat*ones(n,1);
lambda=lambda_tilde;
s=s_hat+delta_s_hat*ones(n,1);


while k<max_iter
    
    eta_k=0.9995;
    
    
    % Step 1
    r_c=AA'*lambda+s-cc;
    r_b=AA*x-bb;
    r_xs=x.*s;
    step_change=cc'*x-bb'*lambda;
    if step_change<Tol_err
        break;
    end
    invs=1./s;
    GG=AA*spdiags(x.*invs,0,n,n)*AA';
    Delta_lambda_aff=GG\(-r_b-AA*((x.*r_c).*invs)+AA*(r_xs.*invs));
    if isnan(sum(Delta_lambda_aff))>0
        break;
    end
    
    Delta_s_aff=-r_c-AA'*Delta_lambda_aff;
    Delta_x_aff=-(r_xs.*invs)-((x.*invs).*Delta_s_aff);
    
    
    % Step 2
    [alpha_aff_pri]=F20150620_alpha_compute(x,Delta_x_aff);  % (14.32a)
    [alpha_aff_dual]=F20150620_alpha_compute(s,Delta_s_aff);% (14.32b)
    mu_aff=(x+alpha_aff_pri*Delta_x_aff)'*(s+alpha_aff_dual*Delta_s_aff)/n; % (14.33)
    mu=x'*s/n;
    
    % Step 3
    sigma=(mu_aff/mu)^3;
    
    % Step 4: (14.35)
    r_xs=x.*s+(Delta_x_aff.*Delta_s_aff)-sigma*mu*ones(n,1);
    Delta_lambda=GG\(-r_b-AA*((x.*r_c).*invs)+AA*(r_xs.*invs));
    Delta_s=-r_c-AA'*Delta_lambda;
    Delta_x=-(r_xs.*invs)-((x.*invs).*Delta_s);
    
    % Step 5:
    [alpha_pri_max]=F20150620_alpha_compute(x,Delta_x); % (14.36)
    [alpha_dual_max]=F20150620_alpha_compute(s,Delta_s); % (14.36)
    alpha_pri=min(1,eta_k*alpha_pri_max); % (14.38)
    alpha_dual=min(1,eta_k*alpha_dual_max);% (14.38)
    
    % Step 6: update
    x=x+alpha_pri*Delta_x;
    s=s+alpha_dual*Delta_s;
    lambda=lambda+alpha_dual*Delta_lambda;
    
    % Step 7: prepare the next iteration
    k=k+1;
    
end

Num_iter=k;

end



function [endpoint1_final,iter]=F20160423_iterative_interpolation(YY,Z,W_tilde,p,n,gamma_hat,sigma_u_hat,endpoint1,endpoint1_stat)

[~,ind]=max(abs(endpoint1_stat));
sign1=sign(endpoint1_stat(ind));
target=sign1*1.96;

diff=10;
iter=1;
while (iter<=10) && (diff>1e-3)
    
    slope=(endpoint1_stat(1)-endpoint1_stat(2))/(endpoint1(1)-endpoint1(2));
    endpoint1=[endpoint1;endpoint1(1)-(endpoint1_stat(1)-target)/slope];
    endpoint1_stat=[endpoint1_stat;F20160423_second_step(YY,Z,W_tilde,p,n,gamma_hat,sigma_u_hat,endpoint1(end))];
    [diff,ind]=max(abs(endpoint1_stat-target));
    endpoint1(ind)=[];
    endpoint1_stat(ind)=[];
    iter=iter+1;
end
endpoint1_final=mean(endpoint1);



end













