clear all;
close all;
clc;

n=500;
p=700;
num_sim=2000;

which_design=1; % i means Example i. Here, Example 1 is Toeplitz design, Example 2 is equal correlation and Example 3 is Fan and Song (2010).



%% setup
a_dense=ones(p,1); 
a_sparse=zeros(p,1);a_sparse(2)=1;

num_grid_power_curve=16; % number of grids in the power curve

hh_11=(0:8/(num_grid_power_curve-1):8)'; % grids of h for dense beta and dense a
hh_10=(0:3.5/(num_grid_power_curve-1):3.5)'; % grids of h for dense beta and sparse a
hh_01=(0:10/(num_grid_power_curve-1):10)'; 
hh_00=(0:0.4/(num_grid_power_curve-1):0.4)';
All_result=NaN(20,num_sim,num_grid_power_curve); % This matrix collects all the 

%% simulations
for jj=1:num_grid_power_curve
   
    %% dense beta and dense a
    h=hh_11(jj);
    tstat_11=NaN(5,num_sim);
    if_dense_beta=1;
    if_dense_a=1;
%     tic;
%     parfor i=1:num_sim
%         [tstat_11(:,i)]=ZhuBradic_one_sample(n,p,a_dense,h,if_dense_beta,if_dense_a,which_design);
%     end
%     toc;
    
    % sparse beta and dense a
    h=hh_01(jj);
    tstat_01=NaN(5,num_sim);
    if_dense_beta=0;
    if_dense_a=1;
%     parfor i=1:num_sim
%         [tstat_01(:,i)]=ZhuBradic_one_sample(n,p,a_dense,h,if_dense_beta,if_dense_a,which_design);
%     end
    
    
   
    %% dense beta and sparse a
    h=hh_10(jj);
    tstat_10=NaN(5,num_sim);
    if_dense_beta=1;
    if_dense_a=0;
%     parfor i=1:num_sim
%         [tstat_10(:,i)]=ZhuBradic_one_sample(n,p,a_sparse,h,if_dense_beta,if_dense_a,which_design);
%     end
    
    
    %% sparse beta and sparse a
    h=hh_00(jj);
    tstat_00=NaN(5,num_sim);
    if_dense_beta=0;
    if_dense_a=0;
    tic;
    parfor i=1:num_sim
        [tstat_00(:,i)]=ZhuBradic_one_sample(n,p,a_sparse,h,if_dense_beta,if_dense_a,which_design);
    end
    toc;
   
    All_result(:,:,jj)=[tstat_11;tstat_10;tstat_01;tstat_00];
end


ccc=All_result(18,:,1)

%% plot power curves
Power_curve=NaN(num_grid_power_curve,20);
for i=1:num_grid_power_curve
    Power_curve(i,:)=mean(abs(All_result(:,:,i))'>1.96);
end
close all;
plot_power_curve(Power_curve,hh_00,hh_11,hh_10,hh_01);


plot_power_curve(Power_curve+1.96*sqrt(Power_curve.*(1-Power_curve)/num_sim),hh_00,hh_11,hh_10,hh_01);
ccc=Power_curve(1:length(hh_00),16:19)

iii=4
cc4=[ccc(:,iii)-1.96*sqrt(ccc(:,iii).*(1-ccc(:,iii))/num_sim),ccc(:,iii),ccc(:,iii)+1.96*sqrt(ccc(:,iii).*(1-ccc(:,iii))/num_sim)]

plot_current=plot(hh_00,ccc);
set(plot_current(1),'LineWidth',2,'Color','b');
set(plot_current(2),'LineWidth',2,'Color','k');
set(plot_current(3),'LineWidth',2,'Color','r');
set(plot_current(4),'LineWidth',2,'Color',[0 .5 0] );


%% plot histograms
ind1=(1:3)'; % dense beta and dense a
ind2=(6:9)'; % dense beta and sparse a
ind3=(11:13)'; % sparse beta and dense a
ind4=(16:19)'; % sparse beta and sparse a

% close all;
% plot_histogram(All_result(ind4,:,1))












