%% prepare data
clear all;
clc;
close all;
load('Data_McCracken_Ng_NBER.mat');
yy=floor(dates);
mon=round((dates-yy)*12);
ind=find(mon==0);
mon(ind)=ones*12;
yy(ind)=yy(ind)-1;
time=100*yy+mon;
load('stock_market_returns.mat')

data=[data,NBER];

start_month=find(yyyymm==195903);
yyyymm(1:start_month-1)=[];
r(1:start_month-1)=[];
end_month=find(time==yyyymm(end));
dates(end_month+1:end)=[];
data(end_month+1:end,:)=[];

Y=r;
X=data;
NaN_data=sum(isnan(X));
ind= NaN_data>30;
X(:,ind)=[];
% NaN_data=sum(isnan(X));
Xtrim=X(21:end-30,:);
X(:,(sum(isnan(Xtrim))>0))=[];

ind=find(max(isnan(X)')>0);
X(ind,:)=[];
Y(ind)=[];
dates(ind)=[];
dates(end)=[];

X(end,:)=[];
Y(1)=[];
NBER=X(:,end);
X(:,end)=[];
% [U,S,V]=svd(X);
X=[X,X.^2,X.^3,X.^4];
meanX=mean(X);
stdX=std(X);
[TX,pX]=size(X);
XX=(X-ones(TX,1)*meanX)/diag(stdX);


meanY=mean(Y);
stdY=std(Y);
YY=(Y-meanY)/stdY;

yy=floor(dates);
mon=round((dates-yy)*12);
ind=find(mon==0);
mon(ind)=ones*12;
yy(ind)=yy(ind)-1;
time=100*yy+mon;

T0=find(time==197912)

Y_train=YY(1:T0);
X_train=XX(1:T0,:);



ind_exp=find(NBER(T0+1:end)==0)+T0;
ind_rec=find(NBER(T0+1:end)==1)+T0;

a1=mean(XX(ind_exp,:))';
a2=mean(XX(ind_rec,:))';


%% real data application
tstat_exp=ZhuBradic_test_unknown_variance(Y_train,X_train,a1,0)
tstat_rec=ZhuBradic_test_unknown_variance(Y_train,X_train,a2,0)
tstat_diff=ZhuBradic_test_unknown_variance(Y_train,X_train,a2-a1,0)

interv_exp=(Grid_confidence_interval_linear_functional(Y_train,X_train,0,a1)*stdY+meanY)*12
interv_rec=(Grid_confidence_interval_linear_functional(Y_train,X_train,0,a2)*stdY+meanY)*12
interv_diff=(Grid_confidence_interval_linear_functional(Y_train,X_train,0,a2-a1)*stdY+meanY)*12

[mean(Y(ind_exp)),mean(Y(ind_rec))]
[h,pv,ci,info]=ttest2(Y(ind_exp),Y(ind_rec))

A=XX(T0+1:end,:)';
[~,num_a]=size(A);
inter_each_time=NaN(2,num_a);
tic;
parfor i=1:num_a
    inter_each_time(:,i)=Grid_confidence_interval_linear_functional(Y_train,X_train,0,A(:,i));
end
toc;

%% plot

figure;
plot(Y)

time(T0+1)
time(end)
x_axis=(1980+1/12:1/12:2014)';
TTT=length(inter_each_time);
x_axis=x_axis(1:TTT);
inter_converted=(inter_each_time*stdY+meanY)*12;
close all;
figure;
h=plot(x_axis,inter_converted','Color','k')
hold on;
for i=1:length(x_axis)-1
    xx1=[x_axis(i);x_axis(i);x_axis(i+1);x_axis(i+1)];
    yy1=[inter_converted(1,i);inter_converted(2,i);inter_converted(2,i+1);inter_converted(1,i+1)];
    s=fill(xx1,yy1,[0,0,1]);
    set(s,'EdgeColor','None');
    alpha(s,.7)
end
cc=refline(0,0);
set(cc,'Color','k','LineWidth',1.5);

NBER_used=NBER(T0+1:end);
starting=[];
ending=[];
turnon=0;
for t=1:length(NBER_used)
    if turnon==0 && NBER_used(t)==1
        starting=[starting;t];
        turnon=1;
    end
    if turnon==1 && NBER_used(t)==0
        ending=[ending;t-1];
        turnon=0;
    end
end
starting=starting;
ending=ending;

shade(x_axis(starting),x_axis(ending),[0.2,0.2,0.2]);












