function [All_stat]=ZhuBradic_one_sample(n,p,a,h,if_dense_beta,if_dense_a,which_design)


[X,SigmaX]=generate_design(n,p,which_design);
Omega=inv(SigmaX);

if if_dense_beta==1
    beta=ones(p,1)/sqrt(p)*3;
else
    beta=zeros(p,1);
    beta(1:2)=ones*0.8;
end

epsl=randn(n,1);
epsl=epsl-mean(epsl);
Y=X*beta+epsl;

% Y=Y-mean(Y);
% X=X-ones(n,1)*mean(X);



g0=a'*beta+h;


[ZhuBradic_stat_unknown_SigmaX]=ZhuBradic_test_unknown_variance(Y,X,a,g0);


b=(SigmaX\a)/((a'/SigmaX)*a);

Z=X*b;
V=Y-Z*g0;
L=Z.*V;
ZhuBradic_stat_known_SigmaX=sqrt(n)*mean(L)/sqrt(mean(L.^2));



%% VBRD and BCH

% [beta_hat,Binfo]  = lasso(X,Y,'CV',5,'Standardize',0);   beta_hat=beta_hat(:,Binfo.IndexMinMSE); 
[beta_hat,~]  = lasso(X,Y,'Lambda',sqrt(2*log(p)/n),'Standardize',0);
% [beta_hat,~]=scaledLasso(X,Y); 

Omega_hat=zeros(p,p);
tau_hat=ones(p,1);

for jj=1:p
    if abs(a(jj))>1e-5
        
         lambda_used=sqrt(2*log(p)/n)/sqrt(Omega(jj,jj));   [gg_hat,~]  = lasso([X(:,1:jj-1),X(:,jj+1:end)],X(:,jj),'Lambda',lambda_used,'Standardize',0);
%         [gg_hat,Binfo]  = lasso([X(:,1:jj-1),X(:,jj+1:end)],X(:,jj),'CV',5,'Standardize',0);   gg_hat=gg_hat(:,Binfo.IndexMinMSE); lambda_used=Binfo.Lambda(Binfo.IndexMinMSE);
%         [gg_hat,lambda_used]=scaledLasso([X(:,1:jj-1),X(:,jj+1:end)],X(:,jj)); 
        
        Omega_hat(jj,jj)=1;
        Omega_hat(jj,1:jj-1)=-gg_hat(1:jj-1);
        Omega_hat(jj,jj+1:end)=-gg_hat(jj:end);
        tau_hat(jj)=mean((X(:,jj)-[X(:,1:jj-1),X(:,jj+1:end)]*gg_hat).^2)+2*lambda_used*sum(abs(gg_hat));
    end
end
Omega_hat=diag(1./tau_hat)*Omega_hat;

beta_hat_debiased=beta_hat+(Omega_hat*X')*(Y-X*beta_hat)/n;
stat_VBRD=sqrt(n)*(a'*beta_hat_debiased-g0)/sqrt(mean((a'*Omega_hat*X').^2));


%% BCH
if if_dense_a~=1
   
    ind_a=find(abs(a)>1e-3);
    ind=[ind_a; find(abs(beta_hat)>1e-3)];
    for jj=1:length(ind_a);
        jjj=ind_a(jj);
        [gg_hat,~]  = lasso([X(:,1:jjj-1),X(:,jjj+1:end)],X(:,jjj),'Lambda',sqrt(2*log(p)/n)/sqrt(Omega(jjj,jjj)),'Standardize',0);
%         [gg_hat,Binfo]  = lasso([X(:,1:jjj-1),X(:,jjj+1:end)],X(:,jjj),'CV',5,'Standardize',0); gg_hat=gg_hat(:,Binfo.IndexMinMSE);
%         [gg_hat]=scaledLasso([X(:,1:jjj-1),X(:,jjj+1:end)],X(:,jjj));
        indd=find(abs(gg_hat)>1e-3);
        ind2=find(indd>jjj-1);
        indd(ind2)=indd(ind2)+1;
        ind=[ind;indd];
    end
    ind_set=unique(ind);
    XX=X(:,ind_set);
    beta_OLS_post=(XX'*XX)\(XX'*Y);
    mu_hat=a(ind_set)'*beta_OLS_post;
    V_hat=inv(XX'*XX/n);
    Stat_BCH=sqrt(n)*(mu_hat-g0)/sqrt(a(ind_set)'*V_hat*a(ind_set));
    
else
    Stat_BCH=NaN(1);
end



All_stat=[ZhuBradic_stat_unknown_SigmaX;ZhuBradic_stat_known_SigmaX;stat_VBRD;Stat_BCH;NaN(1)];

end

function [beta_hat_final,lambda_used]=scaledLasso(X,Y)
[n,p]=size(X);
[beta_hat,Binfo]=lasso(X,Y,'Standardize',0);
lambda=Binfo.Lambda';
num_lambda=length(lambda);
Loss=NaN(num_lambda,1);
for t=1:num_lambda
    sigma_lambda=lambda(t)/sqrt(2*log(p)/n);
    Loss(t)=abs(sqrt(mean((Y-X*beta_hat(:,t)-Binfo.Intercept(t)).^2))/sigma_lambda-1);
end

[~,ind]=min(Loss);

beta_hat_final=beta_hat(:,ind);
lambda_used=lambda(ind);
end

