function [t_stat_unknown_SigmaX]=ZhuBradic_test_unknown_variance(Y,X,a,g0)

% the output is the test stat, which converges to standard Gaussian under
% the null hypothesis

% a is the vector representing the linear functional under testing and g0
% is the hypothesized value of the linear functional.


[n,p]=size(X);

b=a/(a'*a);

Z=X*b;
[Ua,~,~]=svd(eye(p,p)-b*a');Ua(:,end)=[];
W_tilde=X*Ua;
V=Y-Z*g0;

eta=0.5*sqrt(log(p)/n);
rho0=0.01;
a1=eta*sqrt(Z'*Z/n);
a2=rho0*(Z'*Z)/n*0.5;





[gamma_hat,~]=ZhuBradic_fast_estimator(W_tilde,Z,a1,a2,rho0);

sigma_u_hat=sqrt(mean((Z-W_tilde*gamma_hat).^2));



rho0=0.01;
a1=eta*sqrt(V'*V/n);
a2=rho0*(V'*V)/n*0.5;

[pi_hat,rho_hat]=ZhuBradic_fast_estimator(W_tilde,V,a1,a2,rho0);

sigma_epsl_hat=sqrt(mean((V-W_tilde*pi_hat).^2));

t_stat_unknown_SigmaX=(Z-W_tilde*gamma_hat)'*(V-W_tilde*pi_hat)/(sqrt(n)*sigma_u_hat*sigma_epsl_hat);


