function [X,SigmaX]=generate_design(n,p,which_type)

switch which_type
    
    case 1 % Toeplitz
        rhoX=0.4;
        SigmaX=eye(p,p);
        for i=1:p
            for j=1:p
                if i~=j
                    SigmaX(i,j)=rhoX^(abs(i-j));
                end
            end
        end
        X=zscore(randn(n,p)*sqrtm(SigmaX));
        
    case 2 % Equal correlation
        rhoX=0.4;
        SigmaX=eye(p,p);
        for i=1:p
            for j=1:p
                if i~=j
                    SigmaX(i,j)=rhoX;
                end
            end
        end
        X=zscore(randn(n,p)*sqrtm(SigmaX));
        
    case 3  % Fan and Song (2010)     
        q=15;
        X=NaN(n,p);
        p1=floor(p/3);
        p2=floor(2*p/3);
        m=p2-p1;
        rho=0.4;
        a=zeros(p1,1);
        a(1:q)=ones*sqrt(rho/(1-rho));
        for i=1:n
            epsl=randn(1);
            X(i,1:p1)=(randn(p1,1)+a*epsl)./sqrt(1+a.^2);
            U=rand(m,1)-0.5;
            X(i,p1+1:p2)=-sign(U).*log(1-2*abs(U));
            MM=rand(p-p2,1)>0.5;
            X(i,p2+1:end)=(randn(p-p2,1)-1).*MM+(1+randn(p-p2,1)*sqrt(0.5)).*(1-MM);
        end
        X=zscore(X);
        
        SigmaX=eye(p,p);
        for j1=1:q
            for j2=1:q
                if j1~=j2
                    SigmaX(j1,j2)=rho;
                end
            end
        end
        
end
