function []=plot_power_curve(Power_curve,hh_00,hh_11,hh_10,hh_01)

[jj,~]=size(Power_curve);

% sparse a and sparse beta
fig('units','inches','width',7,'height',5,'font','Helvetica','fontsize',12);
curve_point_estimate=Power_curve(1:jj,16:19);
plot_current=plot(hh_00(1:jj),curve_point_estimate);
set(plot_current(1),'LineWidth',2,'Color','b');
set(plot_current(2),'LineWidth',2,'Color','k');
set(plot_current(3),'LineWidth',2,'Color','r');
set(plot_current(4),'LineWidth',2,'Color',[0 .5 0] );
legend('Unknown Variance','Known Variance','VBRD','BCH')
hold on;
% Conf bands
num_sim=500;
lower_bnd=NaN(jj,4);
upper_bnd=NaN(jj,4);
for i=1:4
    lower_bnd(:,i)=curve_point_estimate(:,i)-1.96*sqrt(curve_point_estimate(:,i).*(1-curve_point_estimate(:,i))/num_sim);
    upper_bnd(:,i)=curve_point_estimate(:,i)+1.96*sqrt(curve_point_estimate(:,i).*(1-curve_point_estimate(:,i))/num_sim);
end

% plot_current=plot(hh_00(1:jj),lower_bnd,'m--');
% set(plot_current(1),'Color','b');
% set(plot_current(2),'Color','k');
% set(plot_current(3),'Color','r');
% set(plot_current(4),'Color',[0 .5 0] );
% 
% plot_current=plot(hh_00(1:jj),upper_bnd,'m--');
% set(plot_current(1),'Color','b');
% set(plot_current(2),'Color','k');
% set(plot_current(3),'Color','r');
% set(plot_current(4),'Color',[0 .5 0] );
% ylim([0,1])
% 
fig('units','inches','width',7,'height',5,'font','Helvetica','fontsize',12);
curve_point_estimate=Power_curve(1:jj,16:19);
cccc=1.96*sqrt(curve_point_estimate.*(1-curve_point_estimate)/num_sim);

colormap=NaN(4,3);
colormap(1,:)=[0,0,1];
colormap(2,:)=[0,0,0];
colormap(3,:)=[1,0,0];
colormap(4,:)=[0,0.5,0];

 bbb=NaN(jj,2,4);
 for i=1:4
     bbb(:,1,i)=cccc(:,i);
     bbb(:,2,i)=cccc(:,i);
 end
boundedline(hh_00(1:jj)', curve_point_estimate', bbb,'alpha','cmap',colormap);
ylim([0,1])
hold on;
plot_current=plot(hh_00(1:jj),curve_point_estimate);
set(plot_current(1),'LineWidth',2,'Color','b');
set(plot_current(2),'LineWidth',2,'Color','k');
set(plot_current(3),'LineWidth',2,'Color','r');
set(plot_current(4),'LineWidth',2,'Color',[0 .5 0] );
h_legend=legend('Unknown Variance','Known Variance','VBRD','BCH')
set(h_legend,'FontSize',20);


% dense a and dense beta
fig('units','inches','width',7,'height',5,'font','Helvetica','fontsize',12);
plot_current=plot(hh_11(1:jj),Power_curve(1:jj,1:3));
set(plot_current(1),'LineWidth',2,'Color','b');
set(plot_current(2),'LineWidth',2,'Color','k');
set(plot_current(3),'LineWidth',2,'Color','r');
legend('Unknown Variance','Known Variance','VBRD')
xlim([0,hh_11(jj)])


% dense beta and sparse a
fig('units','inches','width',7,'height',5,'font','Helvetica','fontsize',12);
plot_current=plot(hh_10(1:jj),Power_curve(1:jj,6:9));
set(plot_current(1),'LineWidth',2,'Color','b');
set(plot_current(2),'LineWidth',2,'Color','k');
set(plot_current(3),'LineWidth',2,'Color','r');
set(plot_current(4),'LineWidth',2,'Color',[0 .5 0] );
legend('Unknown Variance','Known Variance','VBRD','BCH');
xlim([0,hh_10(jj)])


% sparse beta and dense a
fig('units','inches','width',7,'height',5,'font','Helvetica','fontsize',12);
plot_current=plot(hh_01(1:jj),Power_curve(1:jj,11:13));
set(plot_current(1),'LineWidth',2,'Color','b');
set(plot_current(2),'LineWidth',2,'Color','k');
set(plot_current(3),'LineWidth',2,'Color','r');
legend('Unknown Variance','Known Variance','VBRD');
xlim([0,hh_01(jj)])

